Page MenuHomePhabricator

App Shortcuts homescreen support for Wikipedia Android app
Closed, ResolvedPublic

Description

Background

Android Oreo adds support for app shortcuts by long pressing on the app icon. This has already been implemented on the iOS app (T114297). More information is available at https://developer.android.com/guide/topics/ui/shortcuts.html. As an example, I attached a screenshot of the iOS version.

User story

As a frequent Wikipedia App user, I want a faster way to access commonly features without having to open to the Explore feed every time.

Proposed on Android

Add initial app shortcuts to the app icon on long press.

  • Search - opens to search screen in app - use icon "ic_search" from Material icons set
  • Random - opens a random article in the article stack - use icon "ic_casino" from Material icons set
  • Continue reading - open the article stack to the top-most article tab - use icon "icon_arrow_forward" from Material icons set


Note that the order of shortcuts in the menu cascades out from the App icon, with Search appearing first, then Continue Reading, followed by Random.

See mock with redlines on Zeplin:
https://zpl.io/VD8kWgV labeled "App shortcut menu"

Event Timeline

Daylen created this task.Aug 28 2017, 5:59 AM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptAug 28 2017, 5:59 AM
Jhernandez moved this task from Needs triage to Triaged on the Mobile board.Aug 28 2017, 10:18 AM
RHo updated the task description. (Show Details)Aug 28 2017, 4:38 PM
RHo updated the task description. (Show Details)Aug 28 2017, 7:10 PM

Change 377356 had a related patch set uploaded (by Cooltey; owner: Cooltey):
[apps/android/wikipedia@master] Add App Shortcuts feature In this update: 1. Add app shortcuts feature for Android 7.1 or higher 2. Created three icons with circled background 3. Setup pinned shortcuts feature when open the app, and pinned shortcuts will be created dynamically

https://gerrit.wikimedia.org/r/377356

Change 377356 merged by jenkins-bot:
[apps/android/wikipedia@master] Add App Shortcuts feature In this update: 1. Add app shortcuts feature for Android 7.1 or higher 2. Created three icons with circled background 3. Setup pinned shortcuts feature when open the app, and pinned shortcuts will be created dynamically

https://gerrit.wikimedia.org/r/377356

ABorbaWMF added subscribers: RHo, ABorbaWMF.

Tested on a Pixel with Android 7.1.1 on 2.6.203-alpha-2017-09-13

This looks good functionally. I noticed a couple small issues visually:

  1. The ordering is different from the screenshots in the original description. They are ordered Random, Continue, and Search from top to bottom. In the screenshot Search is the top most.
  2. In the two languages I tested the text was not yet localized.



@RHo, let me know if we should move this ticket to sign-off and handle the two visual issues in other tickets. Thanks!

thanks @ABorbaWMF - yes the order should be Search first and therefore closest to the App icon, so that's actually my fault in the mock. Picked up a few other visual issues though and have additional info based on some q's on the patch so moving back for now...

RHo updated the task description. (Show Details)Sep 13 2017, 9:47 PM
RHo added a comment.Sep 13 2017, 9:54 PM

Hi @cooltey - I've updated the mock in the task description to reflect the correct order of shortcut items (1/Search 2/Continue 3/Random). Also tried to answer your questions in the gerrit patch below. Just fyi in future, feel free to ping me to go over and can keep the ticket in "Doing", "Code review" or even knock back to "Needs Design" column if there is still info missing rather than moving to QA.

Q1. App icon image width and height?

The icons should also be 24x24dp when inside the individual shortcut icons (see screenshot below showing 'actual' sizes are larger)

Expected
Actual
  • The search/continue reading/random icons within the shortcut menu should actually be a slightly smaller 18x18dp inside 32x32dp circles

Q2. Should "Random" get a article from the offline compilation?

  • Random gets a random article as if user has tapped "Randomizer" in the Explore feed.

Q3. Should we show a message when click on "Continue reading" if no article has been read?
– A: If there are no articles open, let's just open a tab in the article stack which default opens to the Main page.

Also, per Anthony's comment, just wanted to check that the shortcut labels should already have localized string values.

Thanks @RHo !

About the questions:

Q1:

  • Thanks for the information! It helps!

Q2: Should "Random" get a article from the offline compilation?

  • For this description, that's my fault, I did not describe it well.
  • It should be: Should "Random" get an article from the offline compilation when the device is in an airplane mode or no internet access? The "Randomizer" in the Explore feed actually does that, but I am not sure should we do the same thing in this condition.

Q3:

  • Like the idea which default opens to the Main page, let's do it!

About the localized string values, I will check with Dmitry and Michael to go through the processes.

Thanks again!

RHo added a comment.Sep 14 2017, 11:04 AM

no worries @cooltey - and yes, just confirming the random should behave like Randomizer on the feed without connectivity – ie. get a random article from an offline source if available (reading list articles, article packs).

Change 378191 had a related patch set uploaded (by Cooltey; owner: Cooltey):
[apps/android/wikipedia@master] Add App Shortcuts icons for the homescreen

https://gerrit.wikimedia.org/r/378191

Side question: should these replace the old homescreen widgets (i.e., should we disable them for versions for which App Shortcuts are available, and eventually phase them out as we stop supporting legacy versions)?

cooltey added a comment.EditedSep 15 2017, 9:19 PM

I agreed with Michael, especially the "search wikipedia" widget.

RHo added a comment.Sep 15 2017, 9:28 PM

I think it's better to keep for now for those people who have the search or today widget, they may not know that these new shortcuts exist and be annoyed that the widget is suddenly gone...

Side question: should these replace the old homescreen widgets (i.e., should we disable them for versions for which App Shortcuts are available, and eventually phase them out as we stop supporting legacy versions)?

Only 16% of Android devices use Nougat or Oreo (the only versions of Android which support app shortcuts), so unless if the Foundation has found that the widgets have low usage and high development costs, I would highly recommend that the app keeps them.

Only meant to suggest disabling for Nougat and Oreo ("versions for which App Shortcuts are available"). But, I'm happy to not do this, too!

Change 378191 merged by jenkins-bot:
[apps/android/wikipedia@master] Add App Shortcuts icons for the homescreen

https://gerrit.wikimedia.org/r/378191

Dbrant closed this task as Resolved.Sep 26 2017, 3:14 PM